/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC12F1840
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"
#include <stdio.h>
#include "lcd_lib2.h"
#include "i2c_lib2.h"

// O[oϐ錾
unsigned long T1pulse;      // TIMER1 Gate Single Pulse ModeJEg
unsigned long T1cycle;      // TIMER1 Gate Single Pulse + Toggle ModeJEg
unsigned int Flag;      // tO

// vg^Cv錾
void TMR2_Interrupt(void);      // Timer2֐

// Wo͊֐p჌x֐`
void putch(unsigned char data) {
    lcd_data(data);         // t\Wo͊֐Ƃ
}

/*
                         Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    TMR2_SetInterruptHandler(TMR2_Interrupt);       // TMR2_Interrupt:[U[֐̒`
    
    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();      // O[o荞݋

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();      // ӊ荞݋

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

//     
    lcd_init();     // LCD

    T1pulse = 0;
    T1cycle = 0;
    Flag = 0;     
    
    while (1)
    {
        // Add your application code
        
        lcd_cmd(0x80);          // LCD1s
            printf("%lu        ", T1pulse);     // GateMpX\ 

        lcd_cmd(0xC0);          // LCD2s
            printf("%lu        ", T1cycle);     // GateMTCN\ 

        __delay_ms(200);        // 0.2sec
       
    }
}

// Timer2֐
void TMR2_Interrupt(void) {
    
    if (Flag == 0) {
        RA5 = 1;        // RA5s:Hi
        PR2 = 0x1E;     // 250us
        Flag = 1;       // Flag؂ւ
    }    

    else {
        RA5 = 0;        // RA5s:Lo
        PR2 = 0x5D;     // 750us
        Flag = 0;       // Flag؂ւ    
    }    
}

/**
 End of File
*/
